* ARISE Copper Ball Scroller
	
	opt	c-,ow-,o+
	
* ----------------------------------- offset execlib
OpenLib		equ	-552
CloseLib	equ	-414	
Forbid		equ	-132
Permit		equ	-138
Supervisor	equ	-30

* ----------------------------------- offset gfxlib
LoadView	equ	-222
WaitBlit	equ	-228
WaitTOF		equ	-270
OwnBlit		equ	-456
DisownBlit	equ	-462

* ----------------------------------- offset customs
BLTCON0=$40		
BLTCON1=$42
BLTAFWM=$44
BLTALWM=$46
BLTCPTH=$48
BLTCPTL=$4A
BLTBPTH=$4C
BLTBPTL=$4E
BLTAPTH=$50
BLTAPTL=$52
BLTDPTH=$54
BLTDPTL=$56
BLTSIZE=$58
BLTCMOD=$60
BLTBMOD=$62
BLTAMOD=$64
BLTDMOD=$66
BLTCDAT=$70
BLTBDAT=$72
BLTADAT=$74
DMACONR=$2

* ------------------------------------ offset dmacon
D_init=$8200
D_priB=$400
D_Btpl=$100
D_Copp=$80
D_Blit=$40
D_sprt=$20
D_disk=$10
D_CON=D_init|D_copp|D_Btpl|D_Blit|D_sprt

* ------------------------------------- parametres modifiables
PT=0	; 0=ptplay 2.1a  1=ptreplay

* -------------------------------------
	section	prog,code
	
Start:	movem.l	d0-d7/a0-a6,-(sp)
	
	movea.l	4.w,a6
	lea	GfxName(pc),a1
	moveq	#0,d0
	jsr	OpenLib(a6)
	tst.l	d0
	beq	NoGfx
	
	lea	GfxBase(pc),a0
	move.l	d0,(a0)
	move.l	d0,a6
	
	lea	OldView(pc),a0
	move.l	$22(a6),(a0)
	
	suba.l	a1,a1
	jsr	LoadView(a6)
	
	jsr	WaitTOF(a6)
	jsr	WaitTOF(a6)
	jsr	WaitBlit(a6)
	
	movea.l	4.w,a6
	jsr	Forbid(a6)
	
	bsr	GetVBR
; my init	
	move.l	#Ball,d0
	lea	CLplan,a0
	move.w	#4,d1
	move.l	#40*256,d2
	bsr	Place_Plans
	
	move.l	#sprNull,d0
	lea	CLsprite,a0
	move.w	#7,d1
	move.l	#0,d2
	bsr	Place_Plans

	move.w	#0,d1
	move.l	#0,d2
	move.l	#spr1,d0
	lea	CLsprite0,a0
	bsr	Place_Plans

	move.l	#spr2,d0
	lea	CLsprite1,a0
	bsr	Place_Plans

	move.l	#spr3,d0
	lea	CLsprite2,a0
	bsr	Place_Plans
	
	bsr	InitCop
	bsr	MoveLight
	bsr	MoveSpot
 	bsr	InitZic	
; save	
	bsr	Init
	
* Main Program ------------------------------------------------------
MainVbl:
	move.l	$dff004,d0
	lsr.l	#8,d0
	andi.w	#%111111111,d0
	cmpi.w	#255,d0
	bne.s	MainVbl
	
	bsr	MoveLight		; cycle tab x,y sprite (mouvement)
	bsr	MoveSpot		; install coord. x,y sprites
	
	btst	#10,$dff016		; rmb: stop scroll
	beq.s	Freeze
	
	tst.w	countchar
	bne.s	Inst
	
	movea.l	ptTab0(pc),a0
	cmpi.w	#$ffff,(a0)
	bne.s	.skip
	
	lea	Tab0(pc),a0		; tabcol lettres
	move.l	a0,ptTab0
	
.skip	move.w	(a0),valcurcolor	; nouvelle couleur pour lettre
	addq.l	#2,ptTab0
	
	bsr	GetChar		; prend une nouvelle lettre
	
	move.w	#8,countchar	; 8 colonnes de large

Inst	subq.w	#1,countchar
	
Freeze	bsr	InitBall		; 'dessine' la boule finale

	btst	#10,$dff016
	beq.s	.skip
	bsr	ScrollText		; cre le mouvement H du text
	
.skip	move.w	#$5200,Resolution
	
	btst	#6,$bfe001
	bne	MainVbl
* restore -----------------------------------------------------------	
	bsr	StopZic

	bsr	Restore
	
	movea.l	4.w,a6
	jsr	Permit(a6)
	
	movea.l	GfxBase(pc),a6
	movea.l	OldView(pc),a1
	jsr	LoadView(a6)
	move.l	$26(a6),$dff080
	
	movea.l	a6,a1
	movea.l	4.w,a6
	jsr	CloseLib(a6)
	
NoGfx	movem.l	(sp)+,d0-d7/a0-a6
	moveq	#0,d0
	rts
* ---------------------------------------------	
Init:	lea	$dff000,a6
	lea	Dma(pc),a0
	move.w	2(a6),d0		; save dma
	or.w	d0,(a0)+
	move.w	$1c(a6),d0		; save intena
	or.w	d0,(a0)+
	
	move.w	#$7fff,d0
	move.w	d0,$96(a6)
	move.w	d0,$9a(a6)
	move.w	d0,$9c(a6)
	
	movea.l	VBR(pc),a1
	move.l	$6c(a1),(a0)		; int3 vbl
	
	lea	interrupt(pc),a0
	move.l	a0,$6c(a1)
	move.w	#$c020,$9a(a6)
	
	lea	newcopper,a0
	move.l	a0,$80(a6)
	move.w	#0,$88(a6)
	move.w	#D_con,$96(a6)
	
	rts
* ---------------------------------------------
Restore:	
	lea	$dff000,a6
	move.w	#$7fff,d0
	move.w	d0,$96(a6)
	move.w	d0,$9a(a6)
	move.w	d0,$9c(a6)
	
	lea	Dma(pc),a0
	movea.l	VBR(pc),a1
	move.l	4(a0),$6c(a1)
	move.w	2(a0),$9a(a6)
	move.w	(a0),$96(a6)
	
	rts
* --------------------------------------------
GetVBR:	movea.l	4.w,a6
	btst	#0,$129(a6)
	beq.s	.normal
	
	lea	SuperCode(pc),a5
	jsr	Supervisor(a6)
	
	lea	VBR(pc),a0
	move.l	d0,(a0)
.normal	rts
	CNOP	0,4
SuperCode:	
	dc.l	$4e7a0801	
;	movec Vbr,d0	; 680x0
	rte
* --------------------------------------------
Dma	dc.w	$8000
intena	dc.w	$c000
int3	dc.l	0
GfxBase	dc.l	0
OldView	dc.l	0
VBR	dc.l	0
GfxName	dc.b	'graphics.library',0
	even
* --------------------------------------------
interrupt:	
	movem.l	a0-a6/d0-d7,-(sp)

	lea	$dff000,a6	
	andi.w	#$20,$1e(a6)	; interruption VBL ?
	beq.s	.noInt
	
	bsr.w	PlayZic

	move.w	#$0020,$dff09c	; ok ! interrupt finished	
.noInt	movem.l	(sp)+,a0-a6/d0-d7
	rte	
* --------------------------------------------
Place_plans:		
	move.w	d0,6(a0)
	swap	d0			
	move.w 	d0,2(a0)
	swap	d0
	tst.w	d1
	beq.s	.fin
	add.l	d2,d0
	addq.l	#8,a0
	subq.w	#1,d1
	bra.s	place_plans
.fin	rts
* -------------------------------------------
Vbl:	btst	#0,5(a6)
	beq.s	Vbl
.vbl	btst	#0,5(a6)
	bne.s	.vbl
	rts
* --------------------------------------------
waitblitter	
	btst	#6,$dff002
.loop	btst	#6,$dff002
	bne.s	.loop
	rts
* =======================================================
* COPPER BALL SCROLLER
* =======================================================
InitCop:	
	lea	listwait,a0
	lea	BallStruct(pc),a3	; ball structure
	move.l	#$7107fffe,d1
	moveq	#25-1,d6	; 25 lines
.loopline
	move.l	d1,(a0)+	; wait line
	move.w	#$182,d0
	moveq	#25-1,d7	; 25 columns/colors
.loopcol
	move.w	d0,(a0)+	; color1
	move.w	#0,(a0)+
	addq.w	#2,d0
	dbf	d7,.loopcol
	add.l	(a3)+,d1	; line+h (ball struct)
	dbf	d6,.loopline
	rts	
* --------------------------------------------------------
MoveSpot:	
	move.w	x1(pc),d0		; pos x spr1
	move.w	y1(pc),d1		; pos y spr1
	move.w	#16,d2			; h spr1
	lea	Spr1,a0
	bsr	MoveSpr

	move.w	x2(pc),d0		; pos x spr2
	move.w	y2(pc),d1		; pos y spr2
	move.w	#16,d2			; h spr2
	lea	Spr2,a0
	bsr	MoveSpr

	move.w	x3(pc),d0		; pos x spr3
	move.w	y3(pc),d1		; pos y spr3
	move.w	#16,d2			; h spr3
	lea	Spr3,a0
	bsr	MoveSpr
	rts
* ---------
MoveSpr:	
	neg.w	d0			; x
	neg.w	d1			; y
	addi.w	#$119,d0		; x+$119
	addi.w	#$a4,d1			; y+$a4
	
	moveq	#0,d3			; vertdep255
	
	move.b	d1,(a0)			; y spr
	
	btst	#8,d1
	beq.s	.skip1
	bset	#2,d3
.skip1	add.w	d2,d1			; y+h
	move.b	d1,2(a0)		; y+h spr
	
	btst	#8,d1
	beq.s	.skip2
	bset	#1,d3
.skip2	lsr.w	#1,d0			; x
	bcc.s	.skip3
	bset	#0,d3
.skip3	move.b	d0,1(a0)		; x spr
	move.b	d3,3(a0)		; vertlim
	rts
* --------------------------------------------------------
MoveLight:	
	movea.l	ptTabx1(pc),a0
	cmpa.l	#finTabx1,a0
	bcs.s	.skip
	move.l	#Tabx1,ptTabx1
	movea.l	ptTabx1(pc),a0
.skip	move.w	(a0),x1
	addq.l	#4,ptTabx1

SY1:	movea.l	ptTaby1(pc),a0
	cmpa.l	#finTaby1,a0
	bcs.s	.skip
	move.l	#Taby1,ptTaby1
	movea.l	ptTaby1(pc),a0
.skip	move.w	(a0),y1
	addq.l	#4,ptTaby1
;------
SX2:	movea.l	ptTabx2(pc),a0
	cmpa.l	#finTaby1,a0
	bcs.s	.skip
	move.l	#Taby1,ptTabx2
	movea.l	ptTabx2(pc),a0
.skip	move.w	(a0),x2
	addq.l	#4,ptTabx2

SY2:	movea.l	ptTaby2(pc),a0
	cmpa.l	#finTabx1,a0
	bcs.s	.skip
	move.l	#Tabx1,ptTaby2
	movea.l	ptTaby2(pc),a0
.skip	move.w	(a0),y2
	addq.l	#4,ptTaby2
;------
SX3:	movea.l	ptTabx3(pc),a0
	cmpa.l	#finTabx3,a0
	bcs.s	.skip
	move.l	#Tabx3,ptTabx3
	movea.l	ptTabx3(pc),a0
.skip	move.w	(a0),x3
	addq.l	#4,ptTabx3

SY3:	movea.l	ptTaby3(pc),a0
	cmpa.l	#finTaby1,a0
	bcs.s	.skip
	move.l	#Taby1,ptTaby3
	movea.l	ptTaby3(pc),a0
.skip	move.w	(a0),y3
	addq.l	#4,ptTaby3
	
	rts
* --------------------------------------------------------
GetChar:	
	movea.l	pText(pc),a0
	move.b	(a0),d0
	bne.s	.notend
	
	move.l	#Text,pText
	movea.l	pText(pc),a0
	move.b	(a0),d0
	
.notend	cmpi.b	#1,d0		; test param pos
	beq.s	ChgLine
	
	lea	TabChar(pc),a1
	lea	Font,a2
	
.search	cmp.b	(a1)+,d0
	beq.s	.found
	addq.l	#1,a2
	bra.s	.search
	
.found	lea	BufCharC1(pc),a0	; copy lettre in buf
	bsr	TakeChar
	adda.l	#54,a2

	lea	BufCharC2(pc),a0
	bsr	TakeChar
	adda.l	#54,a2

	lea	BufCharC3(pc),a0
	bsr	TakeChar
	adda.l	#54,a2

	lea	BufCharC4(pc),a0
	bsr	TakeChar
	adda.l	#54,a2

	lea	BufCharC5(pc),a0
	bsr	TakeChar
	adda.l	#54,a2

	lea	BufCharC6(pc),a0
	bsr	TakeChar
	adda.l	#54,a2

	lea	BufCharC7(pc),a0
	bsr	TakeChar
	
	addq.l	#1,pText
	rts
* -------
ChgLine:	
	addq.l	#1,pText
	movea.l	pText(pc),a0
	moveq	#0,d0
	move.b	(a0),d0
	lsl.w	#2,d0
	move.l	d0,pos
	addq.l	#1,pText
	bra	GetChar
* -------
TakeChar:	
	btst	#7,(a2)
	beq.s	.null
	move.w	valcurcolor(pc),(a0)+
	bra.s	C2
.null	move.w	#0,(a0)+

C2:	btst	#6,(a2)
	beq.s	.null
	move.w	valcurcolor(pc),(a0)+
	bra.s	C3
.null	move.w	#0,(a0)+

C3:	btst	#5,(a2)
	beq.s	.null
	move.w	valcurcolor(pc),(a0)+
	bra.s	C4
.null	move.w	#0,(a0)+

C4:	btst	#4,(a2)
	beq.s	.null
	move.w	valcurcolor(pc),(a0)+
	bra.s	C5
.null	move.w	#0,(a0)+

C5:	btst	#3,(a2)
	beq.s	.null
	move.w	valcurcolor(pc),(a0)+
	bra.s	C6
.null	move.w	#0,(a0)+

C6:	btst	#2,(a2)
	beq.s	.null
	move.w	valcurcolor(pc),(a0)+
	bra.s	C7
.null	move.w	#0,(a0)+

C7:	btst	#1,(a2)
	beq.s	.null
	move.w	valcurcolor(pc),(a0)+
	bra.s	C8
.null	move.w	#0,(a0)+

C8:	btst	#0,(a2)
	beq.s	.null
	move.w	valcurcolor(pc),(a0)+
	rts
.null	move.w	#0,(a0)+
	rts
* --------------------------------------------------------
InitBall:	
	lea	listwait,a0
	lea	BallStruct(pc),a3	; ball struct
	move.l	#$7107fffe,d1	; wait line
* ---	
	moveq	#0,d0		; sprite 1 Bleu
	move.w	x1(pc),d0
	addi.w	#$af,d0
	divs	#7,d0
	add.l	d0,d0
	andi.l	#$ffff,d0
	move.l	d0,pt1y

	moveq	#0,d0
	move.w	y1(pc),d0
	addi.w	#$af,d0
	divs	#7,d0
	add.l	d0,d0
	add.l	d0,d0
	andi.l	#$ffff,d0
	move.l	d0,pt1x
* ---
	lea	TabLightB(pc),a2	; source BLEU
	adda.l	pt1x(pc),a2
	
	lea	TabScrText(pc),a4	; 'scrollText'
	adda.l	pos(pc),a4
	
	moveq	#25-1,d6	; 25 lines
LoopLine	
	movea.l	(a2)+,a1
	adda.l	pt1y(pc),a1
	movea.l	(a4)+,a5
	move.w	#$182,d0
	move.l	d1,(a0)+
	moveq	#25-1,d7	; 25 colors/columns
LoopCol	move.w	d0,(a0)+
	move.w	(a1)+,d2
	move.w	(a5)+,d5
	or.w	d5,d2
	move.w	d2,(a0)+
	addq.w	#2,d0
	dbf	d7,LoopCol
	add.l	(a3)+,d1
	dbf	d6,LoopLine
* -------- Do "Light"
	lea	listwait,a0
	lea	BallStruct(pc),a3
	move.l	#$7107fffe,d1
* ---	
	moveq	#0,d0		; sprite 2 Vert
	move.w	x2(pc),d0
	addi.w	#$af,d0
	divs	#7,d0
	add.l	d0,d0
	andi.l	#$ffff,d0
	move.l	d0,pt2y

	moveq	#0,d0
	move.w	y2(pc),d0
	addi.w	#$af,d0
	divs	#7,d0
	add.l	d0,d0
	add.l	d0,d0
	andi.l	#$ffff,d0
	move.l	d0,pt2x
* ---
	moveq	#0,d0		; sprite 3 Rouge
	move.w	x3(pc),d0
	addi.w	#$af,d0
	divs	#7,d0
	add.l	d0,d0
	andi.l	#$ffff,d0
	move.l	d0,pt3y

	moveq	#0,d0
	move.w	y3(pc),d0
	addi.w	#$af,d0
	divs	#7,d0
	add.l	d0,d0
	add.l	d0,d0
	andi.l	#$ffff,d0
	move.l	d0,pt3x
* ---
	lea	TabLightG(pc),a2	; source VERT
	adda.l	pt2x(pc),a2
	
	lea	TabLightR(pc),a4	; source ROUGE
	adda.l	pt3x(pc),a4
	
	moveq	#25-1,d6
LoopLine2	
	movea.l	(a2)+,a1
	adda.l	pt2y(pc),a1
	movea.l	(a4)+,a5
	adda.l	pt3y(pc),a5
	
	move.w	#$182,d0
	move.l	d1,(a0)+
	moveq	#25-1,d7
LoopCol2	
	move.w	d0,(a0)+
	move.w	(a1)+,d2
	or.w	(a5)+,d2
	or.w	d2,(a0)+	
	addq.w	#2,d0
	dbf	d7,LoopCol2
	add.l	(a3)+,d1
	dbf	d6,LoopLine2
	rts
* --------------------------------------------------------
A	set	50			
ScrollText:	
; copy 24 columns/7 lines
	lea	TabColText(pc),a0
	bsr	CopyCol
			
	lea	TabColText+A(pc),a0
	bsr	CopyCol

	lea	TabColText+A*2(pc),a0
	bsr	CopyCol

	lea	TabColText+A*3(pc),a0
	bsr	CopyCol

	lea	TabColText+A*4(pc),a0
	bsr	CopyCol

	lea	TabColText+A*5(pc),a0
	bsr	CopyCol

	lea	TabColText+A*6(pc),a0
	bsr	CopyCol
;----- do scroll
	lea	BufCharC1(pc),a0
	lea	TabColText+A-2(pc),a1
	move.w	(a0),(a1)

	lea	BufCharC2(pc),a0
	lea	TabColText+A*2-2(pc),a1
	move.w	(a0),(a1)

	lea	BufCharC3(pc),a0
	lea	TabColText+A*3-2(pc),a1
	move.w	(a0),(a1)

	lea	BufCharC4(pc),a0
	lea	TabColText+A*4-2(pc),a1
	move.w	(a0),(a1)
	
	lea	BufCharC5(pc),a0
	lea	TabColText+A*5-2(pc),a1
	move.w	(a0),(a1)
	
	lea	BufCharC6(pc),a0
	lea	TabColText+A*6-2(pc),a1
	move.w	(a0),(a1)
	
	lea	BufCharC7(pc),a0
	lea	TabColText+A*7-2(pc),a1
	move.w	(a0),(a1)
;-----
	lea	BufCharC1(pc),a0
	bsr	CopyL
		
	lea	BufCharC2(pc),a0
	bsr	CopyL

	lea	BufCharC3(pc),a0
	bsr	CopyL

	lea	BufCharC4(pc),a0
	bsr	CopyL

	lea	BufCharC5(pc),a0
	bsr	CopyL

	lea	BufCharC6(pc),a0
	bsr	CopyL

	lea	BufCharC7(pc),a0
	bsr	CopyL
	rts
* --------
CopyCol:	
	movea.l	a0,a1
	addq.l	#2,a1
	moveq	#24-1,d7	; 24 columns
.loop	move.w	(a1)+,(a0)+
	dbf	d7,.loop
	rts
* --------
CopyL:	movea.l	a0,a1
	addq.l	#2,a1
	moveq	#7-1,d7		; 7 lines/char
.loop	move.w	(a1)+,(a0)+
	dbf	d7,.loop
	rts
* --------------------------------------------------------
	ifeq	PT
	 include	pt-play_2.1a.s
	elseif
	 include	ptreplay.s
	endc

* --------- buffer 1 lettre : 7 lignes
BufCharC1	ds.w	8
BufCharC2	ds.w	8
BufCharC3	ds.w	8
BufCharC4	ds.w	8
BufCharC5	ds.w	8
BufCharC6	ds.w	8
BufCharC7	ds.w	8
countchar	dc.w	0

TabChar	dc.b	" ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789/.,':-+()"
	dc.b	"?!*\|><",0
	even

* --- paramtre position : 1,pos (30,25,20)
pText	dc.l	Text
Text	dc.b	"     "
	dc.b	1,25,"ARISE IS BREAKING ALL LIMITS !     "
	dc.b	1,30,"WHOOPS,"
	dc.b	" A BALL SCROLLER, INCLUDING 3 LIGHTSOURCES      "
	dc.b	1,20,"ABSOLUTELY GREAT !!!        "
	dc.b	0
	even

pos	dc.l	$64
* --------- coordonnes courantes x,y des 3 sprites 'lightsources'
x1	dc.w	6
y1	dc.w	6
x2	dc.w	6
y2	dc.w	6
x3	dc.w	6
y3	dc.w	6
* ---- tableau des positions sur x,y pour les sprites
ptTabx1	dc.l	Tabx1
ptTaby1	dc.l	Tabx1+185*4
ptTabx2	dc.l	Taby1+70*4
ptTaby2	dc.l	Tabx1+10*4
ptTabx3	dc.l	Tabx3
ptTaby3	dc.l	Taby1+100*4
Tabx1	dc.w	$0001,$0003,$0005,$0007,$0009,$000b,$000e,$0010,$0012,$0014
	dc.w	$0016,$0018,$001a,$001c,$001e,$0020,$0022,$0024,$0026,$0028
	dc.w	$002a,$002c,$002d,$002f,$0031,$0033,$0035,$0036,$0038,$003a
	dc.w	$003c,$003d,$003f,$0041,$0042,$0044,$0045,$0047,$0048,$004a
	dc.w	$004b,$004c,$004e,$004f,$0050,$0052,$0053,$0054,$0055,$0056
	dc.w	$0057,$0058,$0059,$005a,$005b,$005c,$005d,$005d,$005e,$005f
	dc.w	$005f,$0060,$0061,$0061,$0062,$0062,$0062,$0063,$0063,$0063
	dc.w	$0064,$0064,$0064,$0064,$0064,$0064,$0064,$0064,$0064,$0064
	dc.w	$0063,$0063,$0063,$0062,$0062,$0062,$0061,$0061,$0060,$005f
	dc.w	$005f,$005e,$005d,$005d,$005c,$005b,$005a,$0059,$0058,$0057
	dc.w	$0056,$0055,$0054,$0053,$0052,$0050,$004f,$004e,$004c,$004b
	dc.w	$004a,$0048,$0047,$0045,$0044,$0042,$0041,$003f,$003d,$003c
	dc.w	$003a,$0038,$0036,$0035,$0033,$0031,$002f,$002d,$002c,$002a
	dc.w	$0028,$0026,$0024,$0022,$0020,$001e,$001c,$001a,$0018,$0016
	dc.w	$0014,$0012,$0010,$000e,$000b,$0009,$0007,$0005,$0003,$0001
	dc.w	$ffff,$fffd,$fffb,$fff9,$fff7,$fff5,$fff2,$fff0,$ffee,$ffec
	dc.w	$ffea,$ffe8,$ffe6,$ffe4,$ffe2,$ffe0,$ffde,$ffdc,$ffda,$ffd8
	dc.w	$ffd6,$ffd4,$ffd3,$ffd1,$ffcf,$ffcd,$ffcb,$ffca,$ffc8,$ffc6
	dc.w	$ffc4,$ffc3,$ffc1,$ffbf,$ffbe,$ffbc,$ffbb,$ffb9,$ffb8,$ffb6
	dc.w	$ffb5,$ffb4,$ffb2,$ffb1,$ffb0,$ffae,$ffad,$ffac,$ffab,$ffaa
	dc.w	$ffa9,$ffa8,$ffa7,$ffa6,$ffa5,$ffa4,$ffa3,$ffa3,$ffa2,$ffa1
	dc.w	$ffa1,$ffa0,$ff9f,$ff9f,$ff9e,$ff9e,$ff9e,$ff9d,$ff9d,$ff9d
	dc.w	$ff9c,$ff9c,$ff9c,$ff9c,$ff9c,$ff9c,$ff9c,$ff9c,$ff9c,$ff9c
	dc.w	$ff9d,$ff9d,$ff9d,$ff9e,$ff9e,$ff9e,$ff9f,$ff9f,$ffa0,$ffa1
	dc.w	$ffa1,$ffa2,$ffa3,$ffa3,$ffa4,$ffa5,$ffa6,$ffa7,$ffa8,$ffa9
	dc.w	$ffaa,$ffab,$ffac,$ffad,$ffae,$ffb0,$ffb1,$ffb2,$ffb4,$ffb5
	dc.w	$ffb6,$ffb8,$ffb9,$ffbb,$ffbc,$ffbe,$ffbf,$ffc1,$ffc3,$ffc4
	dc.w	$ffc6,$ffc8,$ffca,$ffcb,$ffcd,$ffcf,$ffd1,$ffd3,$ffd4,$ffd6
	dc.w	$ffd8,$ffda,$ffdc,$ffde,$ffe0,$ffe2,$ffe4,$ffe6,$ffe8,$ffea
	dc.w	$ffec,$ffee,$fff0,$fff2,$fff5,$fff7,$fff9,$fffb,$fffd,$ffff
finTabx1
Taby1	dc.w	$0001,$0003,$0005,$0007,$0009,$000b,$000d,$000e,$0010,$0012
	dc.w	$0014,$0016,$0018,$001a,$001b,$001d,$001f,$0021,$0023,$0024
	dc.w	$0026,$0028,$0029,$002b,$002d,$002e,$0030,$0031,$0033,$0034
	dc.w	$0036,$0037,$0039,$003a,$003b,$003d,$003e,$003f,$0040,$0041
	dc.w	$0042,$0043,$0044,$0045,$0046,$0047,$0048,$0049,$004a,$004a
	dc.w	$004b,$004c,$004c,$004d,$004d,$004e,$004e,$004f,$004f,$004f
	dc.w	$0050,$0050,$0050,$0050,$0050,$0050,$0050,$0050,$0050,$0050
	dc.w	$004f,$004f,$004f,$004e,$004e,$004d,$004d,$004c,$004c,$004b
	dc.w	$004a,$004a,$0049,$0048,$0047,$0046,$0045,$0044,$0043,$0042
	dc.w	$0041,$0040,$003f,$003e,$003d,$003b,$003a,$0039,$0037,$0036
	dc.w	$0034,$0033,$0031,$0030,$002e,$002d,$002b,$0029,$0028,$0026
	dc.w	$0024,$0023,$0021,$001f,$001d,$001b,$001a,$0018,$0016,$0014
	dc.w	$0012,$0010,$000e,$000d,$000b,$0009,$0007,$0005,$0003,$0001
	dc.w	$ffff,$fffd,$fffb,$fff9,$fff7,$fff5,$fff3,$fff2,$fff0,$ffee
	dc.w	$ffec,$ffea,$ffe8,$ffe6,$ffe5,$ffe3,$ffe1,$ffdf,$ffdd,$ffdc
	dc.w	$ffda,$ffd8,$ffd7,$ffd5,$ffd3,$ffd2,$ffd0,$ffcf,$ffcd,$ffcc
	dc.w	$ffca,$ffc9,$ffc7,$ffc6,$ffc5,$ffc3,$ffc2,$ffc1,$ffc0,$ffbf
	dc.w	$ffbe,$ffbd,$ffbc,$ffbb,$ffba,$ffb9,$ffb8,$ffb7,$ffb6,$ffb6
	dc.w	$ffb5,$ffb4,$ffb4,$ffb3,$ffb3,$ffb2,$ffb2,$ffb1,$ffb1,$ffb1
	dc.w	$ffb0,$ffb0,$ffb0,$ffb0,$ffb0,$ffb0,$ffb0,$ffb0,$ffb0,$ffb0
	dc.w	$ffb1,$ffb1,$ffb1,$ffb2,$ffb2,$ffb3,$ffb3,$ffb4,$ffb4,$ffb5
	dc.w	$ffb6,$ffb6,$ffb7,$ffb8,$ffb9,$ffba,$ffbb,$ffbc,$ffbd,$ffbe
	dc.w	$ffbf,$ffc0,$ffc1,$ffc2,$ffc3,$ffc5,$ffc6,$ffc7,$ffc9,$ffca
	dc.w	$ffcc,$ffcd,$ffcf,$ffd0,$ffd2,$ffd3,$ffd5,$ffd7,$ffd8,$ffda
	dc.w	$ffdc,$ffdd,$ffdf,$ffe1,$ffe3,$ffe5,$ffe6,$ffe8,$ffea,$ffec
	dc.w	$ffee,$fff0,$fff2,$fff3,$fff5,$fff7,$fff9,$fffb,$fffd,$ffff
finTaby1
Tabx3	dc.w	$006e,$006e,$006e,$006e,$006e,$006e,$006e,$006d,$006d,$006d
	dc.w	$006d,$006d,$006c,$006c,$006c,$006b,$006b,$006b,$006a,$006a
	dc.w	$006a,$0069,$0069,$0068,$0068,$0067,$0067,$0066,$0065,$0065
	dc.w	$0064,$0064,$0063,$0062,$0061,$0061,$0060,$005f,$005e,$005e
	dc.w	$005d,$005c,$005b,$005a,$0059,$0059,$0058,$0057,$0056,$0055
	dc.w	$0054,$0053,$0052,$0051,$0050,$004f,$004e,$004c,$004b,$004a
	dc.w	$0049,$0048,$0047,$0046,$0044,$0043,$0042,$0041,$003f,$003e
	dc.w	$003d,$003c,$003a,$0039,$0038,$0036,$0035,$0034,$0032,$0031
	dc.w	$0030,$002e,$002d,$002b,$002a,$0028,$0027,$0026,$0024,$0023
	dc.w	$0021,$0020,$001e,$001d,$001b,$001a,$0018,$0017,$0015,$0014
	dc.w	$0012,$0011,$000f,$000e,$000c,$000b,$0009,$0008,$0006,$0005
	dc.w	$0003,$0002,$0000,$fffe,$fffd,$fffb,$fffa,$fff8,$fff7,$fff5
	dc.w	$fff4,$fff2,$fff1,$ffef,$ffee,$ffec,$ffeb,$ffe9,$ffe8,$ffe6
	dc.w	$ffe5,$ffe3,$ffe2,$ffe0,$ffdf,$ffdd,$ffdc,$ffda,$ffd9,$ffd8
	dc.w	$ffd6,$ffd5,$ffd3,$ffd2,$ffd0,$ffcf,$ffce,$ffcc,$ffcb,$ffca
	dc.w	$ffc8,$ffc7,$ffc6,$ffc4,$ffc3,$ffc2,$ffc1,$ffbf,$ffbe,$ffbd
	dc.w	$ffbc,$ffba,$ffb9,$ffb8,$ffb7,$ffb6,$ffb5,$ffb4,$ffb2,$ffb1
	dc.w	$ffb0,$ffaf,$ffae,$ffad,$ffac,$ffab,$ffaa,$ffa9,$ffa8,$ffa7
	dc.w	$ffa7,$ffa6,$ffa5,$ffa4,$ffa3,$ffa2,$ffa2,$ffa1,$ffa0,$ff9f
	dc.w	$ff9f,$ff9e,$ff9d,$ff9c,$ff9c,$ff9b,$ff9b,$ff9a,$ff99,$ff99
	dc.w	$ff98,$ff98,$ff97,$ff97,$ff96,$ff96,$ff96,$ff95,$ff95,$ff95
	dc.w	$ff94,$ff94,$ff94,$ff93,$ff93,$ff93,$ff93,$ff93,$ff92,$ff92
	dc.w	$ff92,$ff92,$ff92,$ff92,$ff92,$ff92,$ff92,$ff92,$ff92,$ff92
	dc.w	$ff92,$ff92,$ff93,$ff93,$ff93,$ff93,$ff93,$ff94,$ff94,$ff94
	dc.w	$ff95,$ff95,$ff95,$ff96,$ff96,$ff96,$ff97,$ff97,$ff98,$ff98
	dc.w	$ff99,$ff99,$ff9a,$ff9b,$ff9b,$ff9c,$ff9c,$ff9d,$ff9e,$ff9f
	dc.w	$ff9f,$ffa0,$ffa1,$ffa2,$ffa2,$ffa3,$ffa4,$ffa5,$ffa6,$ffa7
	dc.w	$ffa7,$ffa8,$ffa9,$ffaa,$ffab,$ffac,$ffad,$ffae,$ffaf,$ffb0
	dc.w	$ffb1,$ffb2,$ffb4,$ffb5,$ffb6,$ffb7,$ffb8,$ffb9,$ffba,$ffbc
	dc.w	$ffbd,$ffbe,$ffbf,$ffc1,$ffc2,$ffc3,$ffc4,$ffc6,$ffc7,$ffc8
	dc.w	$ffca,$ffcb,$ffcc,$ffce,$ffcf,$ffd0,$ffd2,$ffd3,$ffd5,$ffd6
	dc.w	$ffd8,$ffd9,$ffda,$ffdc,$ffdd,$ffdf,$ffe0,$ffe2,$ffe3,$ffe5
	dc.w	$ffe6,$ffe8,$ffe9,$ffeb,$ffec,$ffee,$ffef,$fff1,$fff2,$fff4
	dc.w	$fff5,$fff7,$fff8,$fffa,$fffb,$fffd,$fffe,$0000,$0002,$0003
	dc.w	$0005,$0006,$0008,$0009,$000b,$000c,$000e,$000f,$0011,$0012
	dc.w	$0014,$0015,$0017,$0018,$001a,$001b,$001d,$001e,$0020,$0021
	dc.w	$0023,$0024,$0026,$0027,$0028,$002a,$002b,$002d,$002e,$0030
	dc.w	$0031,$0032,$0034,$0035,$0036,$0038,$0039,$003a,$003c,$003d
	dc.w	$003e,$003f,$0041,$0042,$0043,$0044,$0046,$0047,$0048,$0049
	dc.w	$004a,$004b,$004c,$004e,$004f,$0050,$0051,$0052,$0053,$0054
	dc.w	$0055,$0056,$0057,$0058,$0059,$0059,$005a,$005b,$005c,$005d
	dc.w	$005e,$005e,$005f,$0060,$0061,$0061,$0062,$0063,$0064,$0064
	dc.w	$0065,$0065,$0066,$0067,$0067,$0068,$0068,$0069,$0069,$006a
	dc.w	$006a,$006a,$006b,$006b,$006b,$006c,$006c,$006c,$006d,$006d
	dc.w	$006d,$006d,$006d,$006e,$006e,$006e,$006e,$006e,$006e,$006e
finTabx3
* --------- tableau de couleurs et position des 3 sources de lumires 
pt1x	dc.l	$64
pt1y	dc.l	$32
TabLightB	rept	4*7+3
	dc.l	TabColBlack		; noir haut
	endr
A	set	150
	dc.l	TabColBlue+A+2+A*5	
	dc.l	TabColBlue+A+2+A*4
	dc.l	TabColBlue+A+2+A*3
	dc.l	TabColBlue+A+2+A*2
	dc.l	TabColBlue+A+2+A
	dc.l	TabColBlue+A+2
	dc.l	TabColBlue
	dc.l	TabColBlue+A+2
	dc.l	TabColBlue+A+2+A
	dc.l	TabColBlue+A+2+A*2
	dc.l	TabColBlue+A+2+A*3
	dc.l	TabColBlue+A+2+A*4
	dc.l	TabColBlue+A+2+A*5
	rept	4*7+3
	dc.l	TabColBlack		; noir bas		
	endr
* -- Tab couleurs BLEU degrad
TabColBlue	
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$002,$004,$006,$008,$00a,$00c,$00e,$00f,$00e,$00c
	dc.w	$00a,$008,$006,$004,$002,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$002,$004,$006
	dc.w	$008,$00a,$00c,$00e,$00c,$00a,$008,$006,$004,$002
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$002,$004,$006,$008,$00a,$00c,$00a
	dc.w	$008,$006,$004,$002,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$002
	dc.w	$004,$006,$008,$00a,$008,$006,$004,$002,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$002,$004,$006,$008,$006
	dc.w	$004,$002,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$002,$004,$006,$004,$002,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$001,$003,$001
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000
* ------ 
pt2x	dc.l	$64
pt2y	dc.l	$32
TabLightG	rept	4*7+3
	dc.l	TabColBlack		; noir
	endr
A	set	150
	dc.l	TabColGreen+A+2+A*5	
	dc.l	TabColGreen+A+2+A*4
	dc.l	TabColGreen+A+2+A*3
	dc.l	TabColGreen+A+2+A*2
	dc.l	TabColGreen+A+2+A
	dc.l	TabColGreen+A+2
	dc.l	TabColGreen
	dc.l	TabColGreen+A+2
	dc.l	TabColGreen+A+2+A
	dc.l	TabColGreen+A+2+A*2
	dc.l	TabColGreen+A+2+A*3
	dc.l	TabColGreen+A+2+A*4
	dc.l	TabColGreen+A+2+A*5
	rept	4*7+3
	dc.l	TabColBlack		; noir
	endr
* -- Tab couleurs VERT degrad	
TabColGreen	
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$020,$040,$060,$080,$0a0,$0c0,$0e0,$0f0,$0e0,$0c0
	dc.w	$0a0,$080,$060,$040,$020,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$020,$040,$060
	dc.w	$080,$0a0,$0c0,$0e0,$0c0,$0a0,$080,$060,$040,$020
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$020,$040,$060,$080,$0a0,$0c0,$0a0
	dc.w	$080,$060,$040,$020,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$020
	dc.w	$040,$060,$080,$0a0,$080,$060,$040,$020,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$020,$040,$060,$080,$060
	dc.w	$040,$020,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$020,$040,$060,$040,$020,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$010,$030,$010
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000
* ------
pt3x	dc.l	$64
pt3y	dc.l	$32
TabLightR	rept	4*7+3
	dc.l	TabColBlack		; noir
	endr
A	set	150
	dc.l	TabColRed+A+2+A*5
	dc.l	TabColRed+A+2+A*4
	dc.l	TabColRed+A+2+A*3
	dc.l	TabColRed+A+2+A*2
	dc.l	TabColRed+A+2+A
	dc.l	TabColRed+A+2
	dc.l	TabColRed
	dc.l	TabColRed+A+2
	dc.l	TabColRed+A+2+A
	dc.l	TabColRed+A+2+A*2
	dc.l	TabColRed+A+2+A*3
	dc.l	TabColRed+A+2+A*4
	dc.l	TabColRed+A+2+A*5
	rept	4*7+3
	dc.l	TabColBlack		; noir
	endr
* -- Tab couleurs ROUGE degrad	
TabColRed	
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$200,$400,$600,$800,$a00,$c00,$e00,$f00,$e00,$c00
	dc.w	$a00,$800,$600,$400,$200,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$200,$400,$600
	dc.w	$800,$a00,$c00,$e00,$c00,$a00,$800,$600,$400,$200
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$200,$400,$600,$800,$a00,$c00,$a00
	dc.w	$800,$600,$400,$200,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$200
	dc.w	$400,$600,$800,$a00,$800,$600,$400,$200,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$200,$400,$600,$800,$600
	dc.w	$400,$200,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$200,$400,$600,$400,$200,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$100,$300,$100
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000
* -------
* -- Tab couleurs NOIR
TabColBlack	ds.w	75
* ------- scrolltext
TabScrText	rept	4*8+2
	dc.l	TabColBlack		; noir
	endr
A	set	50
	dc.l	TabColText		; lettres (7 lignes)
	dc.l	TabColText+A	
	dc.l	TabColText+A*2
	dc.l	TabColText+A*3
	dc.l	TabColText+A*4
	dc.l	TabColText+A*5
	dc.l	TabColText+A*6	
	rept	4*8+2
	dc.l	TabColBlack
	endr

* -- Buff ScrollText courant
TabColText	ds.w	175

* --------- couleurs des lettres sur 3 lettres consecutives
* - Rouge : $f00 - Vert : $0f0 - Bleu : $00f
valcurcolor	dc.w	$333
ptTab0	dc.l	Tab0
Tab0	dc.w	$ff0,$0f0,$00f,$0ff,$f0f,$f00
	dc.w	-1
* --------- structure verticale de la boule (position des Wait copper)
A	set	$1000000
BallStruct	dc.l	A,A,2*A,3*A,3*A,4*A,5*A,6*A,7*A,7*A,8*A
	dc.l	7*A,7*A,7*A,8*A,7*A,7*A,6*A,5*A,4*A,3*A
	dc.l	3*A,2*A,A,A

* ---------------------------------------------------------- COPPERLIST
	section	copper,data_c	
Newcopper:   
	dc.w 	$008E,$2c81,$0090,$2cc1
	dc.w 	$0092,$0038,$0094,$00d0
	dc.w 	$100
Resolution	dc.w	0
	dc.w	$102,0
	dc.w	$104,$64	
; Modulos 
	dc.w 	$10a,0,$108,0
; Sprites	
CLsprite	
	dc.w	$120,0,$122,0
	dc.w	$124,0,$126,0
	dc.w	$128,0,$12a,0
	dc.w	$12c,0,$12e,0
	dc.w	$130,0,$132,0
CLsprite1	
	dc.w	$134,0,$136,0
CLsprite0	
	dc.w	$138,0,$13a,0
CLsprite2	
	dc.w	$13c,0,$13e,0
; pict	
CLplan	dc.w	$e0,0,$e2,0
	dc.w	$e4,0,$e6,0
	dc.w	$e8,0,$ea,0
	dc.w	$ec,0,$ee,0
	dc.w	$f0,0,$f2,0

	dc.w	$180,0
	dc.w	$1b6,$7f7	; sprite/light colors
	dc.w	$1ba,$77f
	dc.w	$1bc,$f77
	
listwait	ds.l	26*26	; ball struct
	
	dc.l 	-2	; end copperlist
;----------------------------------------------- sprites "light"
spr1	;incbin	"data/ariseball.spr1" 
	dc.w	0,0
	dc.w	$07c0,$0000
	dc.w	$1ff0,$0000
	dc.w	$3ff8,$0000
	dc.w	$7ffc,$0000
	dc.w	$7ffc,$0000
	dc.w	$fffe,$0000
	dc.w	$fffe,$0000
	dc.w	$fffe,$0000
	dc.w	$fffe,$0000
	dc.w	$fffe,$0000
	dc.w	$7ffc,$0000
	dc.w	$7ffc,$0000
	dc.w	$3ff8,$0000
	dc.w	$1ff0,$0000
	dc.w	$07c0,$0000
	dc.w	$0000,$0000
	dc.w	0,0
spr2	;incbin	"data/ariseball.spr2"
	dc.w	0,0
	dc.w	$07c0,$07c0
	dc.w	$1ff0,$1ff0
	dc.w	$3ff8,$3ff8
	dc.w	$7ffc,$7ffc
	dc.w	$7ffc,$7ffc
	dc.w	$fffe,$fffe
	dc.w	$fffe,$fffe
	dc.w	$fffe,$fffe
	dc.w	$fffe,$fffe
	dc.w	$fffe,$fffe
	dc.w	$7ffc,$7ffc
	dc.w	$7ffc,$7ffc
	dc.w	$3ff8,$3ff8
	dc.w	$1ff0,$1ff0
	dc.w	$07c0,$07c0
	dc.w	$0000,$0000
	dc.w	0,0
spr3	;incbin	"data/ariseball.spr3"
	dc.w	0,0
	dc.w	$0000,$07c0
	dc.w	$0000,$1ff0
	dc.w	$0000,$3ff8
	dc.w	$0000,$7ffc
	dc.w	$0000,$7ffc
	dc.w	$0000,$fffe
	dc.w	$0000,$fffe
	dc.w	$0000,$fffe
	dc.w	$0000,$fffe
	dc.w	$0000,$fffe
	dc.w	$0000,$7ffc
	dc.w	$0000,$7ffc
	dc.w	$0000,$3ff8
	dc.w	$0000,$1ff0
	dc.w	$0000,$07c0
	dc.w	$0000,$0000
	dc.w	0,0

sprNull:	dc.l	0,0
* -----------------------------------------------------
Module:
mt_data	incbin	"mod.squaresnsaws"
Ball	incbin	"ariseballpic.rw"	; 40x256x5
Font	
* Font Ball Scroller
* Chaque valeur represente une ligne de chacune des 54 lettres
* 54 lettres de 7 lignes et 8 colonnes (8 bits = .b)
* ligne 1 --------------------------------
	dc.b $00,$1c,$1c,$1c,$1c,$1c
	dc.b $1c,$1c,$36,$10,$1c,$36
	dc.b $18,$1c,$dc,$1c,$1c,$1c
	dc.b $1c,$1c,$1c,$24,$24,$24
	dc.b $24,$24,$1e,$1c,$1c,$1c
	dc.b $1c,$26,$3e,$1c,$1c,$1c
	dc.b $1c,$06,$00,$00,$38,$00
	dc.b $00,$00,$1c,$70,$3c,$30
	dc.b $00,$00,$10,$10,$10,$00
* ligne 2 --------------------------------
	dc.b $00,$36,$36,$36,$36,$36
	dc.b $36,$36,$36,$10,$36,$36
	dc.b $30,$3e,$f6,$36,$36,$36
	dc.b $36,$36,$36,$66,$66,$66
	dc.b $66,$66,$36,$36,$36,$36
	dc.b $36,$66,$60,$36,$36,$36
	dc.b $36,$0c,$00,$00,$18,$38
	dc.b $00,$38,$30,$18,$66,$78
	dc.b $7c,$38,$38,$18,$30,$00
* ligne 3 --------------------------------
	dc.b $00,$66,$66,$60,$66,$60
	dc.b $60,$60,$66,$30,$66,$66
	dc.b $60,$76,$e6,$66,$66,$66
	dc.b $66,$60,$60,$c6,$c6,$c6
	dc.b $c6,$c6,$66,$66,$66,$66
	dc.b $66,$c6,$c0,$60,$66,$66
	dc.b $66,$18,$00,$00,$08,$38
	dc.b $00,$38,$60,$0c,$06,$78
	dc.b $fe,$38,$7c,$7c,$7c,$00
* ligne 4 -------------------------------- 
	dc.b $00,$c6,$c6,$c0,$c6,$c0
	dc.b $c0,$c0,$c6,$30,$c6,$c6
	dc.b $c0,$d6,$c6,$c6,$c6,$c6
	dc.b $c6,$c0,$c0,$c6,$c6,$c6
	dc.b $c6,$c6,$06,$ce,$c6,$06
	dc.b $06,$c6,$c0,$c0,$c6,$c6
	dc.b $c6,$30,$00,$00,$00,$00
	dc.b $fe,$fe,$c0,$06,$0c,$30
	dc.b $fe,$fe,$fe,$7e,$fc,$00
* ligne 5 --------------------------------  
	dc.b $00,$fe,$fc,$c0,$c6,$f0
	dc.b $f8,$cc,$fe,$30,$06,$fc
	dc.b $c0,$d6,$c6,$c6,$fc,$c2
	dc.b $fc,$7c,$c0,$c6,$c6,$d6
	dc.b $7c,$7e,$7c,$d6,$06,$7c
	dc.b $1e,$7e,$fc,$fc,$1e,$7c
	dc.b $7e,$60,$00,$00,$00,$38
	dc.b $fe,$fe,$c0,$06,$18,$30
	dc.b $7c,$7c,$38,$7c,$7c,$00 
* ligne 6 -------------------------------- 
	dc.b $00,$c6,$c6,$c6,$c6,$c6
	dc.b $c0,$c6,$c6,$30,$c6,$c6
	dc.b $c6,$c6,$c6,$c6,$c0,$cc
	dc.b $c6,$06,$c0,$c6,$6c,$d6
	dc.b $c6,$06,$c0,$e6,$06,$c0
	dc.b $c6,$06,$06,$c6,$06,$c6
	dc.b $06,$c0,$38,$38,$00,$38
	dc.b $00,$38,$c0,$06,$00,$00
	dc.b $00,$38,$38,$18,$30,$00 
* ligne 7 -------------------------------- 
	dc.b $00,$c6,$fc,$7c,$fc,$7e
	dc.b $c0,$7c,$c6,$30,$7c,$c6
	dc.b $7c,$c6,$c6,$7c,$c0,$76
	dc.b $c6,$fc,$c0,$7c,$38,$6c
	dc.b $c6,$fc,$fe,$7c,$06,$fe
	dc.b $7c,$06,$fc,$7c,$06,$7c
	dc.b $fc,$c0,$38,$18,$00,$00
	dc.b $00,$38,$7c,$7c,$18,$30
	dc.b $00,$10,$00,$10,$10,$00
	
	END
